/*
 * Copyright (C) 2010  Internet Systems Consortium, Inc. ("ISC")
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND ISC DISCLAIMS ALL WARRANTIES WITH
 * REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS.  IN NO EVENT SHALL ISC BE LIABLE FOR ANY SPECIAL, DIRECT,
 * INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

/* $Id: ede1ee1e1dd6d0fbd32e06c6727a4544b8f369d9 $ */

/* pseudo-firewall stuff for PCP */

#ifndef __PCP__
#define __PCP__

#include "config.h"

#define PCP_NOT_READY	(10)

void
pcp_send_request(struct transaction *t);

/* was AsyncGetPublicAddress() because it has this side-effect too */
void
pcp_boot(int spcprc);

int
OpenPCPServerSocket(struct transaction *t);

int
OpenPCPSockets(int * sockets);

int
OpenPCPRapidRecovery(void);

void
ProcessPCPRequest(int s);

void
ProcessPCPResponse(struct transaction *t);

void
SendPCPNotification(int *sockets);

#endif
