/*
 * Copyright (C) 2011  Internet Systems Consortium, Inc. ("ISC")
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND ISC DISCLAIMS ALL WARRANTIES WITH
 * REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS.  IN NO EVENT SHALL ISC BE LIABLE FOR ANY SPECIAL, DIRECT,
 * INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

/* $Id: 20e09d0dbb324265b6fff9c41fbb4cb7067508d9 $ */

/*
 * PCP server fake socket include
 *
 * Francis_Dupont@isc.org, October 2011
 *
 */

#include <stdint.h>

typedef uint8_t sa_family_t;
typedef uint32_t socklen_t;

#ifndef AF_INET
#define AF_INET		2
#endif
#ifndef AF_INET6
#define AF_INET6	30
#endif

struct sockaddr {		/* BSD style sockaddr struct */
	uint8_t sa_len;
	sa_family_t sa_family;
	char sa_data[14];
};

struct sockaddr_storage {	/* BSD style sockaddr_storage struct */
	uint8_t ss_len;
	sa_family_t ss_family;
	char ss_pad1[6];	/* up to int64_t alignment */
	int64_t ss_align;	/* for alignment */
	char ss_pad2[112];	/* to size 128 */
};

typedef uint32_t in_addr_t;
typedef uint16_t in_port_t;

#ifndef IPPROTO_TCP
#define IPPROTO_TCP	6
#endif
#ifndef IPPROTO_UDP
#define IPPROTO_UDP	17
#endif
#ifndef IPPROTO_SCTP
#define IPPROTO_SCTP	132
#endif

struct in_addr {		/* IPv4 address */
	in_addr_t s_addr;
};

struct sockaddr_in {		/* BSD style sockaddr_in struct */
	uint8_t sin_len;
	sa_family_t sin_family;
	in_port_t sin_port;
	struct in_addr sin_addr;
	/* no useless sin_zero[8]; */
};

struct in6_addr {		/* IPv6 address */
	uint8_t s6_addr[16];	/* no union, KISS */
};

#ifndef INET6_ADDRSTRLEN
#define INET6_ADDRSTRLEN	46
#endif

struct sockaddr_in6 {
	uint8_t sin6_len;
	sa_family_t sin6_family;
	in_port_t sin6_port;
	/* skip sin6_flowinfo */
	struct in6_addr sin6_addr;
	/* skip sin6_scope_id too */
};
