#! /bin/sh
# $Id: iptables_init_and_clean.sh,v 1.1 2011/05/13 09:58:47 nanard Exp $
# Improved sdctld iptables init script.
# Checks for state of filter before doing anything..

EXTIF=eth0
IPTABLES=/sbin/iptables
EXTIP="`LC_ALL=C /sbin/ifconfig $EXTIF | grep 'inet addr' | awk '{print $2}' | sed -e 's/.*://'`"
NDIRTY="`LC_ALL=C /sbin/iptables -t nat -L -n | grep 'SDCTLD' | awk '{printf $1}'`"
FDIRTY="`LC_ALL=C /sbin/iptables -t filter -L -n | grep 'SDCTLD' | awk '{printf $1}'`"
echo "External IP = $EXTIP"

if [[ $NDIRTY = "SDCTLDChain" ]]; then
        echo "Nat table dirty; Cleaning..."
        $IPTABLES -t nat -F SDCTLD
elif [[ $NDIRTY = "Chain" ]]; then
        echo "Dirty NAT chain but no reference..? Fixsted."
        $IPTABLES -t nat -A PREROUTING -d $EXTIP -i $EXTIF -j SDCTLD
        $IPTABLES -t nat -F SDCTLD
else
        echo "NAT table clean..initalizing.."
        $IPTABLES -t nat -N SDCTLD
        $IPTABLES -t nat -A PREROUTING -d $EXTIP -i $EXTIF -j SDCTLD
fi
if [[ $FDIRTY = "SDCTLDChain" ]]; then
        echo "Filter table dirty; Cleaning..."
        $IPTABLES -t filter -F SDCTLD
elif [[ $FDIRTY = "Chain" ]]; then
        echo "Dirty filter chain but no reference..? Fixsted."
        $IPTABLES -t filter -I FORWARD 4 -i $EXTIF ! -o $EXTIF -j SDCTLD
        $IPTABLES -t filter -F SDCTLD
else
        echo "Filter table clean..initalizing.."
        $IPTABLES -t filter -N SDCTLD
        $IPTABLES -t filter -I FORWARD 4 -i $EXTIF ! -o $EXTIF -j SDCTLD
fi 

